require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_LINUX_IP_H)) {
    eval 'sub _LINUX_IP_H () {1;}' unless defined(&_LINUX_IP_H);
    require 'linux/types.ph';
    require 'asm/byteorder.ph';
    eval 'sub IPTOS_TOS_MASK () {0x1e;}' unless defined(&IPTOS_TOS_MASK);
    eval 'sub IPTOS_TOS {
        my($tos) = @_;
	    eval q((($tos) &IPTOS_TOS_MASK));
    }' unless defined(&IPTOS_TOS);
    eval 'sub IPTOS_LOWDELAY () {0x10;}' unless defined(&IPTOS_LOWDELAY);
    eval 'sub IPTOS_THROUGHPUT () {0x8;}' unless defined(&IPTOS_THROUGHPUT);
    eval 'sub IPTOS_RELIABILITY () {0x4;}' unless defined(&IPTOS_RELIABILITY);
    eval 'sub IPTOS_MINCOST () {0x2;}' unless defined(&IPTOS_MINCOST);
    eval 'sub IPTOS_PREC_MASK () {0xe0;}' unless defined(&IPTOS_PREC_MASK);
    eval 'sub IPTOS_PREC {
        my($tos) = @_;
	    eval q((($tos) &IPTOS_PREC_MASK));
    }' unless defined(&IPTOS_PREC);
    eval 'sub IPTOS_PREC_NETCONTROL () {0xe0;}' unless defined(&IPTOS_PREC_NETCONTROL);
    eval 'sub IPTOS_PREC_INTERNETCONTROL () {0xc0;}' unless defined(&IPTOS_PREC_INTERNETCONTROL);
    eval 'sub IPTOS_PREC_CRITIC_ECP () {0xa0;}' unless defined(&IPTOS_PREC_CRITIC_ECP);
    eval 'sub IPTOS_PREC_FLASHOVERRIDE () {0x80;}' unless defined(&IPTOS_PREC_FLASHOVERRIDE);
    eval 'sub IPTOS_PREC_FLASH () {0x60;}' unless defined(&IPTOS_PREC_FLASH);
    eval 'sub IPTOS_PREC_IMMEDIATE () {0x40;}' unless defined(&IPTOS_PREC_IMMEDIATE);
    eval 'sub IPTOS_PREC_PRIORITY () {0x20;}' unless defined(&IPTOS_PREC_PRIORITY);
    eval 'sub IPTOS_PREC_ROUTINE () {0x;}' unless defined(&IPTOS_PREC_ROUTINE);
    eval 'sub IPOPT_COPY () {0x80;}' unless defined(&IPOPT_COPY);
    eval 'sub IPOPT_CLASS_MASK () {0x60;}' unless defined(&IPOPT_CLASS_MASK);
    eval 'sub IPOPT_NUMBER_MASK () {0x1f;}' unless defined(&IPOPT_NUMBER_MASK);
    eval 'sub IPOPT_COPIED {
        my($o) = @_;
	    eval q((($o) &IPOPT_COPY));
    }' unless defined(&IPOPT_COPIED);
    eval 'sub IPOPT_CLASS {
        my($o) = @_;
	    eval q((($o) &IPOPT_CLASS_MASK));
    }' unless defined(&IPOPT_CLASS);
    eval 'sub IPOPT_NUMBER {
        my($o) = @_;
	    eval q((($o) &IPOPT_NUMBER_MASK));
    }' unless defined(&IPOPT_NUMBER);
    eval 'sub IPOPT_CONTROL () {0x;}' unless defined(&IPOPT_CONTROL);
    eval 'sub IPOPT_RESERVED1 () {0x20;}' unless defined(&IPOPT_RESERVED1);
    eval 'sub IPOPT_MEASUREMENT () {0x40;}' unless defined(&IPOPT_MEASUREMENT);
    eval 'sub IPOPT_RESERVED2 () {0x60;}' unless defined(&IPOPT_RESERVED2);
    eval 'sub IPOPT_END () {(0| &IPOPT_CONTROL);}' unless defined(&IPOPT_END);
    eval 'sub IPOPT_NOOP () {(1| &IPOPT_CONTROL);}' unless defined(&IPOPT_NOOP);
    eval 'sub IPOPT_SEC () {(2| &IPOPT_CONTROL| &IPOPT_COPY);}' unless defined(&IPOPT_SEC);
    eval 'sub IPOPT_LSRR () {(3| &IPOPT_CONTROL| &IPOPT_COPY);}' unless defined(&IPOPT_LSRR);
    eval 'sub IPOPT_TIMESTAMP () {(4| &IPOPT_MEASUREMENT);}' unless defined(&IPOPT_TIMESTAMP);
    eval 'sub IPOPT_CIPSO () {(6| &IPOPT_CONTROL| &IPOPT_COPY);}' unless defined(&IPOPT_CIPSO);
    eval 'sub IPOPT_RR () {(7| &IPOPT_CONTROL);}' unless defined(&IPOPT_RR);
    eval 'sub IPOPT_SID () {(8| &IPOPT_CONTROL| &IPOPT_COPY);}' unless defined(&IPOPT_SID);
    eval 'sub IPOPT_SSRR () {(9| &IPOPT_CONTROL| &IPOPT_COPY);}' unless defined(&IPOPT_SSRR);
    eval 'sub IPOPT_RA () {(20| &IPOPT_CONTROL| &IPOPT_COPY);}' unless defined(&IPOPT_RA);
    eval 'sub IPVERSION () {4;}' unless defined(&IPVERSION);
    eval 'sub MAXTTL () {255;}' unless defined(&MAXTTL);
    eval 'sub IPDEFTTL () {64;}' unless defined(&IPDEFTTL);
    eval 'sub IPOPT_OPTVAL () {0;}' unless defined(&IPOPT_OPTVAL);
    eval 'sub IPOPT_OLEN () {1;}' unless defined(&IPOPT_OLEN);
    eval 'sub IPOPT_OFFSET () {2;}' unless defined(&IPOPT_OFFSET);
    eval 'sub IPOPT_MINOFF () {4;}' unless defined(&IPOPT_MINOFF);
    eval 'sub MAX_IPOPTLEN () {40;}' unless defined(&MAX_IPOPTLEN);
    eval 'sub IPOPT_NOP () { &IPOPT_NOOP;}' unless defined(&IPOPT_NOP);
    eval 'sub IPOPT_EOL () { &IPOPT_END;}' unless defined(&IPOPT_EOL);
    eval 'sub IPOPT_TS () { &IPOPT_TIMESTAMP;}' unless defined(&IPOPT_TS);
    eval 'sub IPOPT_TS_TSONLY () {0;}' unless defined(&IPOPT_TS_TSONLY);
    eval 'sub IPOPT_TS_TSANDADDR () {1;}' unless defined(&IPOPT_TS_TSANDADDR);
    eval 'sub IPOPT_TS_PRESPEC () {3;}' unless defined(&IPOPT_TS_PRESPEC);
    eval 'sub IPV4_BEET_PHMAXLEN () {8;}' unless defined(&IPV4_BEET_PHMAXLEN);
    if(defined(&__LITTLE_ENDIAN_BITFIELD)) {
    }
 elsif(defined (&__BIG_ENDIAN_BITFIELD)) {
    } else {
	die("Please fix <asm/byteorder.h>");
    }
    eval("sub IPV4_DEVCONF_FORWARDING () { 1; }") unless defined(&IPV4_DEVCONF_FORWARDING);
    eval("sub IPV4_DEVCONF_MC_FORWARDING () { 2; }") unless defined(&IPV4_DEVCONF_MC_FORWARDING);
    eval("sub IPV4_DEVCONF_PROXY_ARP () { 3; }") unless defined(&IPV4_DEVCONF_PROXY_ARP);
    eval("sub IPV4_DEVCONF_ACCEPT_REDIRECTS () { 4; }") unless defined(&IPV4_DEVCONF_ACCEPT_REDIRECTS);
    eval("sub IPV4_DEVCONF_SECURE_REDIRECTS () { 5; }") unless defined(&IPV4_DEVCONF_SECURE_REDIRECTS);
    eval("sub IPV4_DEVCONF_SEND_REDIRECTS () { 6; }") unless defined(&IPV4_DEVCONF_SEND_REDIRECTS);
    eval("sub IPV4_DEVCONF_SHARED_MEDIA () { 7; }") unless defined(&IPV4_DEVCONF_SHARED_MEDIA);
    eval("sub IPV4_DEVCONF_RP_FILTER () { 8; }") unless defined(&IPV4_DEVCONF_RP_FILTER);
    eval("sub IPV4_DEVCONF_ACCEPT_SOURCE_ROUTE () { 9; }") unless defined(&IPV4_DEVCONF_ACCEPT_SOURCE_ROUTE);
    eval("sub IPV4_DEVCONF_BOOTP_RELAY () { 10; }") unless defined(&IPV4_DEVCONF_BOOTP_RELAY);
    eval("sub IPV4_DEVCONF_LOG_MARTIANS () { 11; }") unless defined(&IPV4_DEVCONF_LOG_MARTIANS);
    eval("sub IPV4_DEVCONF_TAG () { 12; }") unless defined(&IPV4_DEVCONF_TAG);
    eval("sub IPV4_DEVCONF_ARPFILTER () { 13; }") unless defined(&IPV4_DEVCONF_ARPFILTER);
    eval("sub IPV4_DEVCONF_MEDIUM_ID () { 14; }") unless defined(&IPV4_DEVCONF_MEDIUM_ID);
    eval("sub IPV4_DEVCONF_NOXFRM () { 15; }") unless defined(&IPV4_DEVCONF_NOXFRM);
    eval("sub IPV4_DEVCONF_NOPOLICY () { 16; }") unless defined(&IPV4_DEVCONF_NOPOLICY);
    eval("sub IPV4_DEVCONF_FORCE_IGMP_VERSION () { 17; }") unless defined(&IPV4_DEVCONF_FORCE_IGMP_VERSION);
    eval("sub IPV4_DEVCONF_ARP_ANNOUNCE () { 18; }") unless defined(&IPV4_DEVCONF_ARP_ANNOUNCE);
    eval("sub IPV4_DEVCONF_ARP_IGNORE () { 19; }") unless defined(&IPV4_DEVCONF_ARP_IGNORE);
    eval("sub IPV4_DEVCONF_PROMOTE_SECONDARIES () { 20; }") unless defined(&IPV4_DEVCONF_PROMOTE_SECONDARIES);
    eval("sub IPV4_DEVCONF_ARP_ACCEPT () { 21; }") unless defined(&IPV4_DEVCONF_ARP_ACCEPT);
    eval("sub IPV4_DEVCONF_ARP_NOTIFY () { 22; }") unless defined(&IPV4_DEVCONF_ARP_NOTIFY);
    eval("sub IPV4_DEVCONF_ACCEPT_LOCAL () { 23; }") unless defined(&IPV4_DEVCONF_ACCEPT_LOCAL);
    eval("sub IPV4_DEVCONF_SRC_VMARK () { 24; }") unless defined(&IPV4_DEVCONF_SRC_VMARK);
    eval("sub IPV4_DEVCONF_PROXY_ARP_PVLAN () { 25; }") unless defined(&IPV4_DEVCONF_PROXY_ARP_PVLAN);
    eval("sub IPV4_DEVCONF_ROUTE_LOCALNET () { 26; }") unless defined(&IPV4_DEVCONF_ROUTE_LOCALNET);
    eval("sub IPV4_DEVCONF_IGMPV2_UNSOLICITED_REPORT_INTERVAL () { 27; }") unless defined(&IPV4_DEVCONF_IGMPV2_UNSOLICITED_REPORT_INTERVAL);
    eval("sub IPV4_DEVCONF_IGMPV3_UNSOLICITED_REPORT_INTERVAL () { 28; }") unless defined(&IPV4_DEVCONF_IGMPV3_UNSOLICITED_REPORT_INTERVAL);
    eval("sub __IPV4_DEVCONF_MAX () { 29; }") unless defined(&__IPV4_DEVCONF_MAX);
    eval 'sub IPV4_DEVCONF_MAX () {( &__IPV4_DEVCONF_MAX - 1);}' unless defined(&IPV4_DEVCONF_MAX);
}
1;
