require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_IP_VS_H)) {
    eval 'sub _IP_VS_H () {1;}' unless defined(&_IP_VS_H);
    require 'linux/types.ph';
    eval 'sub IP_VS_VERSION_CODE () {0x10201;}' unless defined(&IP_VS_VERSION_CODE);
    eval 'sub NVERSION {
        my($version) = @_;
	    eval q(($version >> 16) & 0xff, ($version >> 8) & 0xff, $version & 0xff);
    }' unless defined(&NVERSION);
    eval 'sub IP_VS_SVC_F_PERSISTENT () {0x1;}' unless defined(&IP_VS_SVC_F_PERSISTENT);
    eval 'sub IP_VS_SVC_F_HASHED () {0x2;}' unless defined(&IP_VS_SVC_F_HASHED);
    eval 'sub IP_VS_SVC_F_ONEPACKET () {0x4;}' unless defined(&IP_VS_SVC_F_ONEPACKET);
    eval 'sub IP_VS_SVC_F_SCHED1 () {0x8;}' unless defined(&IP_VS_SVC_F_SCHED1);
    eval 'sub IP_VS_SVC_F_SCHED2 () {0x10;}' unless defined(&IP_VS_SVC_F_SCHED2);
    eval 'sub IP_VS_SVC_F_SCHED3 () {0x20;}' unless defined(&IP_VS_SVC_F_SCHED3);
    eval 'sub IP_VS_SVC_F_SCHED_SH_FALLBACK () { &IP_VS_SVC_F_SCHED1;}' unless defined(&IP_VS_SVC_F_SCHED_SH_FALLBACK);
    eval 'sub IP_VS_SVC_F_SCHED_SH_PORT () { &IP_VS_SVC_F_SCHED2;}' unless defined(&IP_VS_SVC_F_SCHED_SH_PORT);
    eval 'sub IP_VS_DEST_F_AVAILABLE () {0x1;}' unless defined(&IP_VS_DEST_F_AVAILABLE);
    eval 'sub IP_VS_DEST_F_OVERLOAD () {0x2;}' unless defined(&IP_VS_DEST_F_OVERLOAD);
    eval 'sub IP_VS_STATE_NONE () {0x;}' unless defined(&IP_VS_STATE_NONE);
    eval 'sub IP_VS_STATE_MASTER () {0x1;}' unless defined(&IP_VS_STATE_MASTER);
    eval 'sub IP_VS_STATE_BACKUP () {0x2;}' unless defined(&IP_VS_STATE_BACKUP);
    eval 'sub IP_VS_BASE_CTL () {(64+1024+64);}' unless defined(&IP_VS_BASE_CTL);
    eval 'sub IP_VS_SO_SET_NONE () { &IP_VS_BASE_CTL;}' unless defined(&IP_VS_SO_SET_NONE);
    eval 'sub IP_VS_SO_SET_INSERT () {( &IP_VS_BASE_CTL+1);}' unless defined(&IP_VS_SO_SET_INSERT);
    eval 'sub IP_VS_SO_SET_ADD () {( &IP_VS_BASE_CTL+2);}' unless defined(&IP_VS_SO_SET_ADD);
    eval 'sub IP_VS_SO_SET_EDIT () {( &IP_VS_BASE_CTL+3);}' unless defined(&IP_VS_SO_SET_EDIT);
    eval 'sub IP_VS_SO_SET_DEL () {( &IP_VS_BASE_CTL+4);}' unless defined(&IP_VS_SO_SET_DEL);
    eval 'sub IP_VS_SO_SET_FLUSH () {( &IP_VS_BASE_CTL+5);}' unless defined(&IP_VS_SO_SET_FLUSH);
    eval 'sub IP_VS_SO_SET_LIST () {( &IP_VS_BASE_CTL+6);}' unless defined(&IP_VS_SO_SET_LIST);
    eval 'sub IP_VS_SO_SET_ADDDEST () {( &IP_VS_BASE_CTL+7);}' unless defined(&IP_VS_SO_SET_ADDDEST);
    eval 'sub IP_VS_SO_SET_DELDEST () {( &IP_VS_BASE_CTL+8);}' unless defined(&IP_VS_SO_SET_DELDEST);
    eval 'sub IP_VS_SO_SET_EDITDEST () {( &IP_VS_BASE_CTL+9);}' unless defined(&IP_VS_SO_SET_EDITDEST);
    eval 'sub IP_VS_SO_SET_TIMEOUT () {( &IP_VS_BASE_CTL+10);}' unless defined(&IP_VS_SO_SET_TIMEOUT);
    eval 'sub IP_VS_SO_SET_STARTDAEMON () {( &IP_VS_BASE_CTL+11);}' unless defined(&IP_VS_SO_SET_STARTDAEMON);
    eval 'sub IP_VS_SO_SET_STOPDAEMON () {( &IP_VS_BASE_CTL+12);}' unless defined(&IP_VS_SO_SET_STOPDAEMON);
    eval 'sub IP_VS_SO_SET_RESTORE () {( &IP_VS_BASE_CTL+13);}' unless defined(&IP_VS_SO_SET_RESTORE);
    eval 'sub IP_VS_SO_SET_SAVE () {( &IP_VS_BASE_CTL+14);}' unless defined(&IP_VS_SO_SET_SAVE);
    eval 'sub IP_VS_SO_SET_ZERO () {( &IP_VS_BASE_CTL+15);}' unless defined(&IP_VS_SO_SET_ZERO);
    eval 'sub IP_VS_SO_SET_MAX () { &IP_VS_SO_SET_ZERO;}' unless defined(&IP_VS_SO_SET_MAX);
    eval 'sub IP_VS_SO_GET_VERSION () { &IP_VS_BASE_CTL;}' unless defined(&IP_VS_SO_GET_VERSION);
    eval 'sub IP_VS_SO_GET_INFO () {( &IP_VS_BASE_CTL+1);}' unless defined(&IP_VS_SO_GET_INFO);
    eval 'sub IP_VS_SO_GET_SERVICES () {( &IP_VS_BASE_CTL+2);}' unless defined(&IP_VS_SO_GET_SERVICES);
    eval 'sub IP_VS_SO_GET_SERVICE () {( &IP_VS_BASE_CTL+3);}' unless defined(&IP_VS_SO_GET_SERVICE);
    eval 'sub IP_VS_SO_GET_DESTS () {( &IP_VS_BASE_CTL+4);}' unless defined(&IP_VS_SO_GET_DESTS);
    eval 'sub IP_VS_SO_GET_DEST () {( &IP_VS_BASE_CTL+5);}' unless defined(&IP_VS_SO_GET_DEST);
    eval 'sub IP_VS_SO_GET_TIMEOUT () {( &IP_VS_BASE_CTL+6);}' unless defined(&IP_VS_SO_GET_TIMEOUT);
    eval 'sub IP_VS_SO_GET_DAEMON () {( &IP_VS_BASE_CTL+7);}' unless defined(&IP_VS_SO_GET_DAEMON);
    eval 'sub IP_VS_SO_GET_MAX () { &IP_VS_SO_GET_DAEMON;}' unless defined(&IP_VS_SO_GET_MAX);
    eval 'sub IP_VS_CONN_F_FWD_MASK () {0x7;}' unless defined(&IP_VS_CONN_F_FWD_MASK);
    eval 'sub IP_VS_CONN_F_MASQ () {0x;}' unless defined(&IP_VS_CONN_F_MASQ);
    eval 'sub IP_VS_CONN_F_LOCALNODE () {0x1;}' unless defined(&IP_VS_CONN_F_LOCALNODE);
    eval 'sub IP_VS_CONN_F_TUNNEL () {0x2;}' unless defined(&IP_VS_CONN_F_TUNNEL);
    eval 'sub IP_VS_CONN_F_DROUTE () {0x3;}' unless defined(&IP_VS_CONN_F_DROUTE);
    eval 'sub IP_VS_CONN_F_BYPASS () {0x4;}' unless defined(&IP_VS_CONN_F_BYPASS);
    eval 'sub IP_VS_CONN_F_SYNC () {0x20;}' unless defined(&IP_VS_CONN_F_SYNC);
    eval 'sub IP_VS_CONN_F_HASHED () {0x40;}' unless defined(&IP_VS_CONN_F_HASHED);
    eval 'sub IP_VS_CONN_F_NOOUTPUT () {0x80;}' unless defined(&IP_VS_CONN_F_NOOUTPUT);
    eval 'sub IP_VS_CONN_F_INACTIVE () {0x100;}' unless defined(&IP_VS_CONN_F_INACTIVE);
    eval 'sub IP_VS_CONN_F_OUT_SEQ () {0x200;}' unless defined(&IP_VS_CONN_F_OUT_SEQ);
    eval 'sub IP_VS_CONN_F_IN_SEQ () {0x400;}' unless defined(&IP_VS_CONN_F_IN_SEQ);
    eval 'sub IP_VS_CONN_F_SEQ_MASK () {0x600;}' unless defined(&IP_VS_CONN_F_SEQ_MASK);
    eval 'sub IP_VS_CONN_F_NO_CPORT () {0x800;}' unless defined(&IP_VS_CONN_F_NO_CPORT);
    eval 'sub IP_VS_CONN_F_TEMPLATE () {0x1000;}' unless defined(&IP_VS_CONN_F_TEMPLATE);
    eval 'sub IP_VS_CONN_F_ONE_PACKET () {0x2000;}' unless defined(&IP_VS_CONN_F_ONE_PACKET);
    eval 'sub IP_VS_CONN_F_BACKUP_MASK () {( &IP_VS_CONN_F_FWD_MASK |  &IP_VS_CONN_F_NOOUTPUT |  &IP_VS_CONN_F_INACTIVE |  &IP_VS_CONN_F_SEQ_MASK |  &IP_VS_CONN_F_NO_CPORT |  &IP_VS_CONN_F_TEMPLATE );}' unless defined(&IP_VS_CONN_F_BACKUP_MASK);
    eval 'sub IP_VS_CONN_F_BACKUP_UPD_MASK () {( &IP_VS_CONN_F_INACTIVE |  &IP_VS_CONN_F_SEQ_MASK);}' unless defined(&IP_VS_CONN_F_BACKUP_UPD_MASK);
    eval 'sub IP_VS_CONN_F_NFCT () {(1<< 16);}' unless defined(&IP_VS_CONN_F_NFCT);
    eval 'sub IP_VS_CONN_F_DEST_MASK () {( &IP_VS_CONN_F_FWD_MASK |  &IP_VS_CONN_F_ONE_PACKET |  &IP_VS_CONN_F_NFCT | 0);}' unless defined(&IP_VS_CONN_F_DEST_MASK);
    eval 'sub IP_VS_SCHEDNAME_MAXLEN () {16;}' unless defined(&IP_VS_SCHEDNAME_MAXLEN);
    eval 'sub IP_VS_PENAME_MAXLEN () {16;}' unless defined(&IP_VS_PENAME_MAXLEN);
    eval 'sub IP_VS_IFNAME_MAXLEN () {16;}' unless defined(&IP_VS_IFNAME_MAXLEN);
    eval 'sub IP_VS_PEDATA_MAXLEN () {255;}' unless defined(&IP_VS_PEDATA_MAXLEN);
    eval 'sub IPVS_GENL_NAME () {"IPVS";}' unless defined(&IPVS_GENL_NAME);
    eval 'sub IPVS_GENL_VERSION () {0x1;}' unless defined(&IPVS_GENL_VERSION);
    eval("sub IPVS_CMD_UNSPEC () { 0; }") unless defined(&IPVS_CMD_UNSPEC);
    eval("sub IPVS_CMD_NEW_SERVICE () { 1; }") unless defined(&IPVS_CMD_NEW_SERVICE);
    eval("sub IPVS_CMD_SET_SERVICE () { 2; }") unless defined(&IPVS_CMD_SET_SERVICE);
    eval("sub IPVS_CMD_DEL_SERVICE () { 3; }") unless defined(&IPVS_CMD_DEL_SERVICE);
    eval("sub IPVS_CMD_GET_SERVICE () { 4; }") unless defined(&IPVS_CMD_GET_SERVICE);
    eval("sub IPVS_CMD_NEW_DEST () { 5; }") unless defined(&IPVS_CMD_NEW_DEST);
    eval("sub IPVS_CMD_SET_DEST () { 6; }") unless defined(&IPVS_CMD_SET_DEST);
    eval("sub IPVS_CMD_DEL_DEST () { 7; }") unless defined(&IPVS_CMD_DEL_DEST);
    eval("sub IPVS_CMD_GET_DEST () { 8; }") unless defined(&IPVS_CMD_GET_DEST);
    eval("sub IPVS_CMD_NEW_DAEMON () { 9; }") unless defined(&IPVS_CMD_NEW_DAEMON);
    eval("sub IPVS_CMD_DEL_DAEMON () { 10; }") unless defined(&IPVS_CMD_DEL_DAEMON);
    eval("sub IPVS_CMD_GET_DAEMON () { 11; }") unless defined(&IPVS_CMD_GET_DAEMON);
    eval("sub IPVS_CMD_SET_CONFIG () { 12; }") unless defined(&IPVS_CMD_SET_CONFIG);
    eval("sub IPVS_CMD_GET_CONFIG () { 13; }") unless defined(&IPVS_CMD_GET_CONFIG);
    eval("sub IPVS_CMD_SET_INFO () { 14; }") unless defined(&IPVS_CMD_SET_INFO);
    eval("sub IPVS_CMD_GET_INFO () { 15; }") unless defined(&IPVS_CMD_GET_INFO);
    eval("sub IPVS_CMD_ZERO () { 16; }") unless defined(&IPVS_CMD_ZERO);
    eval("sub IPVS_CMD_FLUSH () { 17; }") unless defined(&IPVS_CMD_FLUSH);
    eval("sub __IPVS_CMD_MAX () { 18; }") unless defined(&__IPVS_CMD_MAX);
    eval 'sub IPVS_CMD_MAX () {( &__IPVS_CMD_MAX - 1);}' unless defined(&IPVS_CMD_MAX);
    eval("sub IPVS_CMD_ATTR_UNSPEC () { 0; }") unless defined(&IPVS_CMD_ATTR_UNSPEC);
    eval("sub IPVS_CMD_ATTR_SERVICE () { 1; }") unless defined(&IPVS_CMD_ATTR_SERVICE);
    eval("sub IPVS_CMD_ATTR_DEST () { 2; }") unless defined(&IPVS_CMD_ATTR_DEST);
    eval("sub IPVS_CMD_ATTR_DAEMON () { 3; }") unless defined(&IPVS_CMD_ATTR_DAEMON);
    eval("sub IPVS_CMD_ATTR_TIMEOUT_TCP () { 4; }") unless defined(&IPVS_CMD_ATTR_TIMEOUT_TCP);
    eval("sub IPVS_CMD_ATTR_TIMEOUT_TCP_FIN () { 5; }") unless defined(&IPVS_CMD_ATTR_TIMEOUT_TCP_FIN);
    eval("sub IPVS_CMD_ATTR_TIMEOUT_UDP () { 6; }") unless defined(&IPVS_CMD_ATTR_TIMEOUT_UDP);
    eval("sub __IPVS_CMD_ATTR_MAX () { 7; }") unless defined(&__IPVS_CMD_ATTR_MAX);
    eval 'sub IPVS_CMD_ATTR_MAX () {( &__IPVS_CMD_ATTR_MAX - 1);}' unless defined(&IPVS_CMD_ATTR_MAX);
    eval("sub IPVS_SVC_ATTR_UNSPEC () { 0; }") unless defined(&IPVS_SVC_ATTR_UNSPEC);
    eval("sub IPVS_SVC_ATTR_AF () { 1; }") unless defined(&IPVS_SVC_ATTR_AF);
    eval("sub IPVS_SVC_ATTR_PROTOCOL () { 2; }") unless defined(&IPVS_SVC_ATTR_PROTOCOL);
    eval("sub IPVS_SVC_ATTR_ADDR () { 3; }") unless defined(&IPVS_SVC_ATTR_ADDR);
    eval("sub IPVS_SVC_ATTR_PORT () { 4; }") unless defined(&IPVS_SVC_ATTR_PORT);
    eval("sub IPVS_SVC_ATTR_FWMARK () { 5; }") unless defined(&IPVS_SVC_ATTR_FWMARK);
    eval("sub IPVS_SVC_ATTR_SCHED_NAME () { 6; }") unless defined(&IPVS_SVC_ATTR_SCHED_NAME);
    eval("sub IPVS_SVC_ATTR_FLAGS () { 7; }") unless defined(&IPVS_SVC_ATTR_FLAGS);
    eval("sub IPVS_SVC_ATTR_TIMEOUT () { 8; }") unless defined(&IPVS_SVC_ATTR_TIMEOUT);
    eval("sub IPVS_SVC_ATTR_NETMASK () { 9; }") unless defined(&IPVS_SVC_ATTR_NETMASK);
    eval("sub IPVS_SVC_ATTR_STATS () { 10; }") unless defined(&IPVS_SVC_ATTR_STATS);
    eval("sub IPVS_SVC_ATTR_PE_NAME () { 11; }") unless defined(&IPVS_SVC_ATTR_PE_NAME);
    eval("sub __IPVS_SVC_ATTR_MAX () { 12; }") unless defined(&__IPVS_SVC_ATTR_MAX);
    eval 'sub IPVS_SVC_ATTR_MAX () {( &__IPVS_SVC_ATTR_MAX - 1);}' unless defined(&IPVS_SVC_ATTR_MAX);
    eval("sub IPVS_DEST_ATTR_UNSPEC () { 0; }") unless defined(&IPVS_DEST_ATTR_UNSPEC);
    eval("sub IPVS_DEST_ATTR_ADDR () { 1; }") unless defined(&IPVS_DEST_ATTR_ADDR);
    eval("sub IPVS_DEST_ATTR_PORT () { 2; }") unless defined(&IPVS_DEST_ATTR_PORT);
    eval("sub IPVS_DEST_ATTR_FWD_METHOD () { 3; }") unless defined(&IPVS_DEST_ATTR_FWD_METHOD);
    eval("sub IPVS_DEST_ATTR_WEIGHT () { 4; }") unless defined(&IPVS_DEST_ATTR_WEIGHT);
    eval("sub IPVS_DEST_ATTR_U_THRESH () { 5; }") unless defined(&IPVS_DEST_ATTR_U_THRESH);
    eval("sub IPVS_DEST_ATTR_L_THRESH () { 6; }") unless defined(&IPVS_DEST_ATTR_L_THRESH);
    eval("sub IPVS_DEST_ATTR_ACTIVE_CONNS () { 7; }") unless defined(&IPVS_DEST_ATTR_ACTIVE_CONNS);
    eval("sub IPVS_DEST_ATTR_INACT_CONNS () { 8; }") unless defined(&IPVS_DEST_ATTR_INACT_CONNS);
    eval("sub IPVS_DEST_ATTR_PERSIST_CONNS () { 9; }") unless defined(&IPVS_DEST_ATTR_PERSIST_CONNS);
    eval("sub IPVS_DEST_ATTR_STATS () { 10; }") unless defined(&IPVS_DEST_ATTR_STATS);
    eval("sub __IPVS_DEST_ATTR_MAX () { 11; }") unless defined(&__IPVS_DEST_ATTR_MAX);
    eval 'sub IPVS_DEST_ATTR_MAX () {( &__IPVS_DEST_ATTR_MAX - 1);}' unless defined(&IPVS_DEST_ATTR_MAX);
    eval("sub IPVS_DAEMON_ATTR_UNSPEC () { 0; }") unless defined(&IPVS_DAEMON_ATTR_UNSPEC);
    eval("sub IPVS_DAEMON_ATTR_STATE () { 1; }") unless defined(&IPVS_DAEMON_ATTR_STATE);
    eval("sub IPVS_DAEMON_ATTR_MCAST_IFN () { 2; }") unless defined(&IPVS_DAEMON_ATTR_MCAST_IFN);
    eval("sub IPVS_DAEMON_ATTR_SYNC_ID () { 3; }") unless defined(&IPVS_DAEMON_ATTR_SYNC_ID);
    eval("sub __IPVS_DAEMON_ATTR_MAX () { 4; }") unless defined(&__IPVS_DAEMON_ATTR_MAX);
    eval 'sub IPVS_DAEMON_ATTR_MAX () {( &__IPVS_DAEMON_ATTR_MAX - 1);}' unless defined(&IPVS_DAEMON_ATTR_MAX);
    eval("sub IPVS_STATS_ATTR_UNSPEC () { 0; }") unless defined(&IPVS_STATS_ATTR_UNSPEC);
    eval("sub IPVS_STATS_ATTR_CONNS () { 1; }") unless defined(&IPVS_STATS_ATTR_CONNS);
    eval("sub IPVS_STATS_ATTR_INPKTS () { 2; }") unless defined(&IPVS_STATS_ATTR_INPKTS);
    eval("sub IPVS_STATS_ATTR_OUTPKTS () { 3; }") unless defined(&IPVS_STATS_ATTR_OUTPKTS);
    eval("sub IPVS_STATS_ATTR_INBYTES () { 4; }") unless defined(&IPVS_STATS_ATTR_INBYTES);
    eval("sub IPVS_STATS_ATTR_OUTBYTES () { 5; }") unless defined(&IPVS_STATS_ATTR_OUTBYTES);
    eval("sub IPVS_STATS_ATTR_CPS () { 6; }") unless defined(&IPVS_STATS_ATTR_CPS);
    eval("sub IPVS_STATS_ATTR_INPPS () { 7; }") unless defined(&IPVS_STATS_ATTR_INPPS);
    eval("sub IPVS_STATS_ATTR_OUTPPS () { 8; }") unless defined(&IPVS_STATS_ATTR_OUTPPS);
    eval("sub IPVS_STATS_ATTR_INBPS () { 9; }") unless defined(&IPVS_STATS_ATTR_INBPS);
    eval("sub IPVS_STATS_ATTR_OUTBPS () { 10; }") unless defined(&IPVS_STATS_ATTR_OUTBPS);
    eval("sub __IPVS_STATS_ATTR_MAX () { 11; }") unless defined(&__IPVS_STATS_ATTR_MAX);
    eval 'sub IPVS_STATS_ATTR_MAX () {( &__IPVS_STATS_ATTR_MAX - 1);}' unless defined(&IPVS_STATS_ATTR_MAX);
    eval("sub IPVS_INFO_ATTR_UNSPEC () { 0; }") unless defined(&IPVS_INFO_ATTR_UNSPEC);
    eval("sub IPVS_INFO_ATTR_VERSION () { 1; }") unless defined(&IPVS_INFO_ATTR_VERSION);
    eval("sub IPVS_INFO_ATTR_CONN_TAB_SIZE () { 2; }") unless defined(&IPVS_INFO_ATTR_CONN_TAB_SIZE);
    eval("sub __IPVS_INFO_ATTR_MAX () { 3; }") unless defined(&__IPVS_INFO_ATTR_MAX);
    eval 'sub IPVS_INFO_ATTR_MAX () {( &__IPVS_INFO_ATTR_MAX - 1);}' unless defined(&IPVS_INFO_ATTR_MAX);
}
1;
