require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_PARAM_H)) {
    eval 'sub _SYS_PARAM_H () {1;}' unless defined(&_SYS_PARAM_H);
    eval 'sub __need_NULL () {1;}' unless defined(&__need_NULL);
    require 'stddef.ph';
    require 'sys/types.ph';
    require 'limits.ph';
    require 'endian.ph';
    require 'signal.ph';
    require 'bits/param.ph';
    eval 'sub NBBY () { &CHAR_BIT;}' unless defined(&NBBY);
    if(!defined (&NGROUPS)  && defined (&NGROUPS_MAX)) {
	eval 'sub NGROUPS () { &NGROUPS_MAX;}' unless defined(&NGROUPS);
    }
    if(!defined (&MAXSYMLINKS)  && defined (&SYMLOOP_MAX)) {
	eval 'sub MAXSYMLINKS () { &SYMLOOP_MAX;}' unless defined(&MAXSYMLINKS);
    }
    if(!defined (&CANBSIZ)  && defined (&MAX_CANON)) {
	eval 'sub CANBSIZ () { &MAX_CANON;}' unless defined(&CANBSIZ);
    }
    if(!defined (&MAXPATHLEN)  && defined (&PATH_MAX)) {
	eval 'sub MAXPATHLEN () { &PATH_MAX;}' unless defined(&MAXPATHLEN);
    }
    if(!defined (&NOFILE)  && defined (&OPEN_MAX)) {
	eval 'sub NOFILE () { &OPEN_MAX;}' unless defined(&NOFILE);
    }
    unless(defined(&NCARGS)) {
	if(defined(&ARG_MAX)) {
	    eval 'sub NCARGS () { &ARG_MAX;}' unless defined(&NCARGS);
	} else {
	    eval 'sub NCARGS () { &INT_MAX;}' unless defined(&NCARGS);
	}
    }
    unless(defined(&NOGROUP)) {
	eval 'sub NOGROUP () {65535;}' unless defined(&NOGROUP);
    }
    unless(defined(&NODEV)) {
	eval 'sub NODEV () {(( &dev_t) -1);}' unless defined(&NODEV);
    }
    unless(defined(&DEV_BSIZE)) {
	eval 'sub DEV_BSIZE () {512;}' unless defined(&DEV_BSIZE);
    }
    eval 'sub setbit {
        my($a,$i) = @_;
	    eval q((($a)[($i)/ &NBBY] |= 1<<(($i)% &NBBY)));
    }' unless defined(&setbit);
    eval 'sub clrbit {
        my($a,$i) = @_;
	    eval q((($a)[($i)/ &NBBY] &= ~(1<<(($i)% &NBBY))));
    }' unless defined(&clrbit);
    eval 'sub isset {
        my($a,$i) = @_;
	    eval q((($a)[($i)/ &NBBY] & (1<<(($i)% &NBBY))));
    }' unless defined(&isset);
    eval 'sub isclr {
        my($a,$i) = @_;
	    eval q(((($a)[($i)/ &NBBY] & (1<<(($i)% &NBBY))) == 0));
    }' unless defined(&isclr);
    unless(defined(&howmany)) {
	eval 'sub howmany {
	    my($x, $y) = @_;
    	    eval q(((($x) + (($y) - 1)) / ($y)));
	}' unless defined(&howmany);
    }
    if(defined(&__GNUC__)) {
	eval 'sub roundup {
	    my($x, $y) = @_;
    	    eval q(( &__builtin_constant_p ($y)  &&  &powerof2 ($y) ? ((($x) + ($y) - 1) & ~(($y) - 1)) : (((($x) + (($y) - 1)) / ($y)) * ($y))));
	}' unless defined(&roundup);
    } else {
	eval 'sub roundup {
	    my($x, $y) = @_;
    	    eval q((((($x) + (($y) - 1)) / ($y)) * ($y)));
	}' unless defined(&roundup);
    }
    eval 'sub powerof2 {
        my($x) = @_;
	    eval q((((($x) - 1) & ($x)) == 0));
    }' unless defined(&powerof2);
    eval 'sub MIN {
        my($a,$b) = @_;
	    eval q(((($a)<($b))?($a):($b)));
    }' unless defined(&MIN);
    eval 'sub MAX {
        my($a,$b) = @_;
	    eval q(((($a)>($b))?($a):($b)));
    }' unless defined(&MAX);
}
1;
